package com.agent.attach.demo;

import javassist.ClassPool;
import javassist.CtClass;
import javassist.CtMethod;

import java.lang.instrument.ClassFileTransformer;
import java.lang.instrument.IllegalClassFormatException;
import java.security.ProtectionDomain;

public class MyTransformer implements ClassFileTransformer {
    private String targetClassName;//被增强类的类名
    private String targetMethodName;//被增强的方法名

    public MyTransformer(String targetClassName, String targetMethodName) {
        this.targetClassName = targetClassName;
        this.targetMethodName = targetMethodName;
    }

    @Override
    public byte[] transform(ClassLoader loader, String className, Class<?> classBeingRedefined, ProtectionDomain protectionDomain, byte[] classfileBuffer) throws IllegalClassFormatException {
        try {
            CtClass ctClass = ClassPool.getDefault().get(this.targetClassName);
            CtMethod ctMethod=ctClass.getDeclaredMethod(this.targetMethodName);
            System.out.println(ctMethod.getName());
            ctMethod.insertBefore("System.out.println(\" 11111111111111111111111\");");
            ctClass.writeFile();
            return ctClass.toBytecode();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return null;
    }
}
