package com.agent.non.attach.demo;

import java.lang.instrument.Instrumentation;

public class Agent {
    /**
     *  agentArgs 是 premain 函数得到的程序参数，通过 -javaagent 传入。这个参数是个字符串，如果程序参数有多个，需要程序自行解析这个字符串。
     *  inst 是一个 java.lang.instrument.Instrumentation 的实例，由 JVM 自动传入。
     */
    public static void premain(String agentOps, Instrumentation inst) {
        System.out.println("=========premain方法执行========");
        // 添加Transformer
        inst.addTransformer(new MyTransformer("com.app.App", "hello"));
    }

    /**
     *  带有 Instrumentation 参数的 premain 优先级高于不带此参数的 premain。
     *  如果存在带 Instrumentation 参数的 premain，不带此参数的 premain 将被忽略。
     * @param agentArgs
     */
    public static void premain(String agentArgs) {

    }
}